%global goipath         github.com/mongodb/mongo-tools
%global commit          0f0d8665c1bd075135148e2ad7359bffe2da02b4

# Git hash in https://github.com/mongodb/mongo which corresponds to Version
%global mongohash a14d55980c2cdc565d4704a7e3ad37e4e535c1b2

%global with_check 1


%gometa

Name:		mongo-tools
Version:        4.0.4
Release:        4%{?dist}
Summary:        MongoDB Tools
License:        ASL 2.0
URL:            %{gourl}
Source0:	%{gosource}
# Mongo-tools does not contain man files yet
# - see https://groups.google.com/forum/#!topic/mongodb-dev/t6Sd2Bki12I
Source1:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/bsondump.1
Source2:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongodump.1
Source3:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongoexport.1
Source4:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongofiles.1
Source5:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongoimport.1
Source6:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongooplog.1
Source7:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongorestore.1
Source8:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongostat.1
Source9:        https://github.com/mongodb/mongo/raw/%{mongohash}/debian/mongotop.1
Source10:       https://github.com/mongodb/mongo/raw/%{mongohash}/APACHE-2.0.txt

Patch0:         logvf-fix-formating-directive.patch

BuildRequires:  openssl-devel
BuildRequires:  libpcap-devel
BuildRequires:  mongodb-server

%if ! 0%{?with_bundled}
BuildRequires:  golang(github.com/10gen/escaper)
BuildRequires:  golang(github.com/10gen/openssl)
BuildRequires:  golang(github.com/google/gopacket)
BuildRequires:  golang(github.com/google/gopacket/layers)
BuildRequires:  golang(github.com/google/gopacket/pcap)
BuildRequires:  golang(github.com/google/gopacket/tcpassembly)
BuildRequires:  golang(github.com/howeyc/gopass)
BuildRequires:  golang(github.com/jessevdk/go-flags)
BuildRequires:  golang(github.com/smartystreets/goconvey/convey)
BuildRequires:  golang(github.com/nsf/termbox-go)
BuildRequires:  golang(github.com/patrickmn/go-cache)
BuildRequires:  golang(golang.org/x/crypto/ssh/terminal)
BuildRequires:  golang(gopkg.in/mgo.v2)
BuildRequires:  golang(gopkg.in/mgo.v2/bson)
BuildRequires:  golang(gopkg.in/tomb.v2)
# Needed by bundled github.com/10gen/llmgo
BuildRequires:  golang(github.com/golang/snappy)
BuildRequires:  golang(github.com/xdg/stringprep)
%else
Provides:  bundled(golang(github.com/10gen/escaper))
Provides:  bundled(golang(github.com/10gen/openssl))
Provides:  bundled(golang(github.com/google/gopacket))
Provides:  bundled(golang(github.com/google/gopacket/layers))
Provides:  bundled(golang(github.com/google/gopacket/pcap))
Provides:  bundled(golang(github.com/google/gopacket/tcpassembly))
Provides:  bundled(golang(github.com/howeyc/gopass))
Provides:  bundled(golang(github.com/jessevdk/go-flags))
Provides:  bundled(golang(github.com/smartystreets/goconvey/convey))
Provides:  bundled(golang(github.com/nsf/termbox-go))
Provides:  bundled(golang(github.com/patrickmn/go-cache))
Provides:  bundled(golang(golang.org/x/crypto/ssh/terminal))
Provides:  bundled(golang(gopkg.in/mgo.v2))
Provides:  bundled(golang(gopkg.in/mgo.v2/bson))
Provides:  bundled(golang(gopkg.in/tomb.v2))
# Needed by bundled github.com/10gen/llmgo
Provides:  bundled(golang(github.com/golang/snappy))
Provides:  bundled(golang(github.com/xdg/stringprep))
%endif

# 10gen/llmgo is private repo - https://jira.mongodb.org/browse/TOOLS-1448
#
# It's different from github.com/go-mgo/mgo (mainly socket.go file)
# and unbundling isn't trivial! So using bundled version.
Provides:  bundled(golang(github.com/10gen/llmgo))
Provides:  bundled(golang(github.com/10gen/llmgo/bson))

Conflicts:      mongodb < 3.0.0

%description
The MongoDB tools provides import, export, and diagnostic capabilities.

%package devel
Summary:       %{summary}
BuildArch:     noarch

%description devel
This package contains library source intended for
building other packages which use %{project}/%{repo}.


%prep
%forgesetup
%if ! 0%{?with_bundled}
# Using bundled github.com/10gen/llmgo - see comment above
find vendor/src/ ! -wholename "*llmgo*" -delete || :
#rm -rf vendor/
%endif

%patch0 -p1

sed -i.bak -e "s/built-without-version-string/%{version}/" \
           -e "s/built-without-git-spec/%{commit}/" \
           common/options/options.go


%build
# Make link for mongo-tools itself
mkdir -p src/github.com/mongodb
ln -s ../../../  src/github.com/mongodb/mongo-tools

export GOPATH=$(pwd):$(pwd)/vendor:%{gopath}

mkdir bin
binaries=(bsondump mongostat mongofiles mongoexport mongoimport mongoreplay mongorestore mongodump mongotop)
for bin in "${binaries[@]}"; do
  %gobuild -o bin/${bin} \-tags ssl ${bin}/main/${bin}.go
done

# Copy Apache license
cp %{SOURCE10} $(basename %{SOURCE10})

%install
%goinstall

# main package binary
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 bin/* %{buildroot}%{_bindir}

install -d -m 755            %{buildroot}%{_mandir}/man1
install -p -m 644 %{SOURCE1} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE2} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE3} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE4} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE5} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE6} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE7} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE8} %{buildroot}%{_mandir}/man1/
install -p -m 644 %{SOURCE9} %{buildroot}%{_mandir}/man1/


%if 0%{?with_check}
%check
export GOPATH=%{buildroot}%{gopath}:$(pwd)/vendor:%{gopath}

# Run mongodb server - mongoreplay tests need it
mkdir dbpath
mongod \
  --pidfilepath $PWD/server.pid \
  --logpath     $PWD/server.log \
  --fork \
  --dbpath      $PWD/dbpath \
  --port 20000

%gochecks -r common/db -r common/log -r common/util
#common/db|common/log|common/util: import cycle not allowed in test
%endif

# Cleanup
mongod --dbpath $PWD/dbpath --shutdown

%files
%license LICENSE.md APACHE-2.0.txt
%doc Godeps README.md CONTRIBUTING.md THIRD-PARTY-NOTICES
%{_bindir}/*
%{_mandir}/man1/*

%files devel -f devel.file-list
%license LICENSE.md
%doc Godeps README.md CONTRIBUTING.md THIRD-PARTY-NOTICES

%changelog
* Mon Dec 03 2018 mskalick@redhat.com - 4.0.4-4.git0f0d866
- Fix formatting directives in tests

* Tue Nov 27 2018 mskalick@redhat.com - 4.0.4-3.git0f0d866
- Add mongoreplay binary and update tests

* Mon Nov 26 2018 mskalick@redhat.com - 4.0.4-2.git0f0d866
- Cleanup spec file

* Sat Nov 24 2018 mskalick@redhat.com - 4.0.4-1.git0f0d866
- Rebase to mongo-tools 4.0.4

* Tue Oct 23 2018 Nicolas Mailhot <nim@fedoraproject.org>
- 3.6.3-0.6
- redhat-rpm-config-123 triggers bugs in gosetup, remove it from Go spec files as it’s just an alias
- https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/RWD5YATAYAFWKIDZBB7EB6N5DAO4ZKFM/

* Tue Jul 31 2018 Florian Weimer <fweimer@redhat.com> - 3.6.3-0.5
- Rebuild with fixed binutils


* Mon May 28 2018 mskalick@redhat.com - 3.6.4-0.1.gite657a1d
- Rebase to 3.6.4

* Thu Apr 12 2018 mskalick@redhat.com - Forge-specific packaging variables
- Clean BuildRequirements

* Mon Mar 19 2018 Marek Skalický <mskalick@redhat.com> - 3.6.3-0.2.git2b10d84
- Rebuild for updated dependencies

* Mon Feb 26 2018 Marek Skalický <mskalick@redhat.com> - 3.6.3-0.1.git2b10d84
- Rebase to latest upstream release

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-0.9.git17a5573
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-0.8.git17a5573
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-0.7.git17a5573
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue May 16 2017 Marek Skalický <mskalick@redhat.com> - 3.2.1-0.6.git17a5573
- Exclude ppc64 architecture (missing cgo)

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-0.5.git17a5573
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Jul 21 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.1-0.4.git17a5573
- https://fedoraproject.org/wiki/Changes/golang1.7

* Mon Feb 22 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.2.1-0.3.git17a5573
- https://fedoraproject.org/wiki/Changes/golang1.6

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 3.2.1-0.2.git17a5573
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jan 27 2016 jchaloup <jchaloup@redhat.com> - 3.1.1-0.1.git17a5573
- Update to 3.2.1
  resolves: #1282650

* Mon Nov 09 2015 jchaloup <jchaloup@redhat.com> - 3.0.4-0.2.gitefe71bf
- Update to spec-2.1
  resolves: #1279140

* Mon Jun 22 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.4-1
- Repacked by using gofed tool (thanks to jchaloup@redhat.com)

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon May 11 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.3-1
- Upgrade to version 3.0.3
- Add Apache license

* Mon May 4 2015 Marek Skalicky <mskalick@redhat.com> - 3.0.2-1
- Initial packaging
